"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateAliasInterface = exports.generateInterface = exports.generatePropertySignatures = exports.generatePropertySignatureObject = exports.generateTypeAlias = exports.generateTypeNode = void 0;
const Guard = __importStar(require("../Guard"));
const ToTypeNode = __importStar(require("../toTypeNode"));
const Reference = __importStar(require("./Reference"));
const generateTypeNode = (entryPoint, currentPoint, factory, parameter, context, converterContext) => {
    return ToTypeNode.convert(entryPoint, currentPoint, factory, parameter.schema || { type: "null" }, context, converterContext);
};
exports.generateTypeNode = generateTypeNode;
const generateTypeAlias = (entryPoint, currentPoint, factory, name, parameter, context, converterContext) => {
    return factory.TypeAliasDeclaration.create({
        export: true,
        name: converterContext.escapeDeclarationText(name),
        comment: parameter.description,
        type: exports.generateTypeNode(entryPoint, currentPoint, factory, parameter, context, converterContext),
    });
};
exports.generateTypeAlias = generateTypeAlias;
const generatePropertySignatureObject = (entryPoint, currentPoint, store, factory, parameter, context, converterContext) => {
    if (Guard.isReference(parameter)) {
        const reference = Reference.generate(entryPoint, currentPoint, parameter);
        if (reference.type === "local") {
            context.setReferenceHandler(currentPoint, reference);
            const localRef = store.getParameter(reference.path);
            const isPathProperty = localRef.in === "path";
            const name = converterContext.escapePropertySignatureName(localRef.name);
            const typeElement = factory.PropertySignature.create({
                name: name,
                optional: isPathProperty ? false : !localRef.required,
                comment: localRef.description,
                type: factory.TypeReferenceNode.create({
                    name: context.resolveReferencePath(currentPoint, reference.path).name,
                }),
            });
            return {
                name,
                typeElement: typeElement,
            };
        }
        const isPathProperty = reference.data.in === "path";
        const name = converterContext.escapePropertySignatureName(reference.data.name);
        const typeElement = factory.PropertySignature.create({
            name: name,
            optional: isPathProperty ? false : !reference.data.required,
            comment: reference.data.description,
            type: ToTypeNode.convert(entryPoint, reference.referencePoint, factory, reference.data.schema || { type: "null" }, context, converterContext),
        });
        return {
            name,
            typeElement: typeElement,
        };
    }
    const isPathProperty = parameter.in === "path";
    const name = converterContext.escapePropertySignatureName(parameter.name);
    const typeElement = factory.PropertySignature.create({
        name: name,
        optional: isPathProperty ? false : !parameter.required,
        type: ToTypeNode.convert(entryPoint, currentPoint, factory, parameter.schema || { type: "null" }, context, converterContext),
        comment: parameter.description,
    });
    return {
        name,
        typeElement: typeElement,
    };
};
exports.generatePropertySignatureObject = generatePropertySignatureObject;
const generatePropertySignatures = (entryPoint, currentPoint, store, factory, parameters, context, converterContext) => {
    const typeElementMap = parameters.reduce((all, parameter) => {
        const { name, typeElement } = exports.generatePropertySignatureObject(entryPoint, currentPoint, store, factory, parameter, context, converterContext);
        return { ...all, [name]: typeElement };
    }, {});
    return Object.values(typeElementMap);
};
exports.generatePropertySignatures = generatePropertySignatures;
const generateInterface = (entryPoint, currentPoint, store, factory, name, parameters, context, converterContext) => {
    return factory.InterfaceDeclaration.create({
        export: true,
        name,
        members: exports.generatePropertySignatures(entryPoint, currentPoint, store, factory, parameters, context, converterContext),
    });
};
exports.generateInterface = generateInterface;
/**
 * Alias作成用
 */
const generateAliasInterface = (entryPoint, currentPoint, store, factory, name, parameters, context, converterContext) => {
    return factory.InterfaceDeclaration.create({
        export: true,
        name: converterContext.escapeDeclarationText(name),
        members: exports.generatePropertySignatures(entryPoint, currentPoint, store, factory, parameters, context, converterContext),
    });
};
exports.generateAliasInterface = generateAliasInterface;
//# sourceMappingURL=Parameter.js.map