import ts from "typescript";
import type { OpenApi } from "../../../types";
import { Factory } from "../../TsGenerator";
import * as ConverterContext from "../ConverterContext";
import * as ToTypeNode from "../toTypeNode";
import type * as Walker from "../Walker";
import * as Reference from "./Reference";
export declare const generateTypeNode: (entryPoint: string, currentPoint: string, factory: Factory.Type, parameter: OpenApi.Parameter, context: ToTypeNode.Context, converterContext: ConverterContext.Types) => ts.TypeNode;
export declare const generateTypeAlias: (entryPoint: string, currentPoint: string, factory: Factory.Type, name: string, parameter: OpenApi.Parameter, context: ToTypeNode.Context, converterContext: ConverterContext.Types) => ts.TypeAliasDeclaration;
export declare const generatePropertySignatureObject: (entryPoint: string, currentPoint: string, store: Walker.Store, factory: Factory.Type, parameter: OpenApi.Parameter | OpenApi.Reference, context: ToTypeNode.Context, converterContext: ConverterContext.Types) => {
    name: string;
    typeElement: ts.PropertySignature;
};
export declare const generatePropertySignatures: (entryPoint: string, currentPoint: string, store: Walker.Store, factory: Factory.Type, parameters: (OpenApi.Parameter | OpenApi.Reference)[], context: ToTypeNode.Context, converterContext: ConverterContext.Types) => ts.PropertySignature[];
export declare const generateInterface: (entryPoint: string, currentPoint: string, store: Walker.Store, factory: Factory.Type, name: string, parameters: (OpenApi.Parameter | OpenApi.Reference)[], context: ToTypeNode.Context, converterContext: ConverterContext.Types) => ts.InterfaceDeclaration;
/**
 * Alias作成用
 */
export declare const generateAliasInterface: (entryPoint: string, currentPoint: string, store: Walker.Store, factory: Factory.Type, name: string, parameters: (OpenApi.Parameter | OpenApi.Reference)[], context: ToTypeNode.Context, converterContext: ConverterContext.Types) => ts.InterfaceDeclaration;
