import ts from "typescript";
export interface Params {
    decorators?: readonly ts.Decorator[] | undefined;
    modifiers: readonly ts.Modifier[] | undefined;
    name: string | ts.PropertyName;
    questionOrExclamationToken?: ts.QuestionToken | ts.ExclamationToken | undefined;
    type: ts.TypeNode | undefined;
    initializer?: ts.Expression | undefined;
}
export interface Factory {
    create: (params: Params) => ts.PropertyDeclaration;
}
export declare const create: ({ factory }: Pick<ts.TransformationContext, "factory">) => Factory["create"];
export declare const make: (context: Pick<ts.TransformationContext, "factory">) => Factory;
